Package net.sf.saxon.expr.instruct

## Class ForEachGroup

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ForEachGroup

- All Implemented Interfaces:
    `ContextMappingFunction`, `ContextOriginator`, `ContextSwitchingExpression`, `ExportAgent`, `TailCallReturner`, `Locatable`, `SortKeyEvaluator`, `IdentityComparable`, `Traceable`

      public class ForEachGroup
      extends Instruction
      implements SortKeyEvaluator, ContextMappingFunction, ContextSwitchingExpression

  Handler for xsl:for-each-group elements in stylesheet. This is a new instruction defined in XSLT 2.0

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `GROUP_ADJACENT` |
    `static int` | `GROUP_BY` |
    `static int` | `GROUP_ENDING` |
    `static int` | `GROUP_STARTING` |

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ForEachGroup​(Expression select, Expression action, byte algorithm, Expression key, StringCollator collator, Expression collationNameExpression, SortKeyDefinitionList sortKeys)` | Create a for-each-group instruction

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `boolean` | `allowExtractingCommonSubexpressions()` | Ask whether common subexpressions found in the operands of this expression can be extracted and evaluated outside the expression itself.
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `int` | `computeDependencies()` | Compute the dependencies of an expression, as the union of the dependencies of its subexpressions.
    `int` | `computeSpecialProperties()` | Get the static properties of this expression (other than its type).
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `AtomicValue` | `evaluateSortKey​(int n, XPathContext c)` | Callback for evaluating the sort keys
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `Expression` | `getActionExpression()` | Get the action expression (the content of the for-each-group)
    `byte` | `getAlgorithm()` | Get the grouping algorithm (one of group-by, group-adjacent, group-starting-with, group-ending-with)
    `java.net.URI` | `getBaseURI()` | Get the static base URI of the instruction
    `StringCollator` | `getCollation()` | Get the statically-determined collator, or null if the collation was not determined statically
    `Expression` | `getCollationNameExpression()` | Get the expression which, on evaluation, yields the name of the collation to be used
    `Expression` | `getGroupingKey()` | Get the grouping key expression expression (the group-by or group-adjacent expression, or a PatternSponsor containing the group-starting-with or group-ending-with expression)
    `GroupIterator` | `getGroupIterator​(Expression select, XPathContext context)` |
    `int` | `getInstructionNameCode()` | Get the name of this instruction for diagnostic and tracing purposes
    `ItemType` | `getItemType()` | Get the item type of the items returned by evaluating this instruction
    `int` | `getKeyItemType()` | Get the primitive item type of the key
    `Expression` | `getSelectExpression()` | Get the select expression
    `AtomicComparer[]` | `getSortKeyComparators()` | Get the statically-allocated sort key comparators for sorting at the group level, if known
    `SortKeyDefinitionList` | `getSortKeyDefinitionList()` |
    `SortKeyDefinitionList` | `getSortKeyDefinitions()` | Get the sort keys defined at the for-each-group level, that is, the keys for sorting the groups
    `java.lang.String` | `getStreamerName()` | Get the (partial) name of a class that supports streaming of this kind of expression
    `boolean` | `isComposite()` |
    `boolean` | `isInFork()` |
    `SequenceIterator` | `iterate​(XPathContext context)` | Return an Iterator to iterate over the values of a sequence.
    `SequenceIterator` | `map​(XPathContext context)` | Map one item to a sequence.
    `boolean` | `mayCreateNewNodes()` | Determine whether this instruction creates new nodes.
    `java.lang.Iterable<Operand>` | `operands()` | Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `TailCall` | `processLeavingTail​(Outputter output, XPathContext context)` | ProcessLeavingTail: called to do the real work of this instruction.
    `void` | `setAction​(Expression action)` |
    `void` | `setCollationNameExpression​(Expression collationNameExpression)` |
    `void` | `setComposite​(boolean composite)` |
    `void` | `setIsInFork​(boolean inFork)` |
    `void` | `setKey​(Expression key)` |
    `void` | `setSelect​(Expression select)` |
    `void` | `setSortKeyDefinitions​(SortKeyDefinitionList sortKeyDefinitions)` |
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Perform type checking of an expression and its subexpressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `alwaysCreatesNewNodes, assembleParams, assembleTunnelParams, computeCardinality, dynamicError, evaluateAsString, evaluateItem, getExpressionName, getImplementationMethod, getNetCost, getSourceLocator, isInstruction, isXSLT, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, getCardinality, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, toShortString, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Field Detail

    - #### GROUP_BY

          public static final int GROUP_BY

      See Also:
        Constant Field Values

    - #### GROUP_ADJACENT

          public static final int GROUP_ADJACENT

      See Also:
        Constant Field Values

    - #### GROUP_STARTING

          public static final int GROUP_STARTING

      See Also:
        Constant Field Values

    - #### GROUP_ENDING

          public static final int GROUP_ENDING

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ForEachGroup

          public ForEachGroup​(Expression select,
                              Expression action,
                              byte algorithm,
                              Expression key,
                              StringCollator collator,
                              Expression collationNameExpression,
                              SortKeyDefinitionList sortKeys)

      Create a for-each-group instruction
      Parameters:
        `select` - the select expression (selects the population to be grouped)
        `action` - the body of the for-each-group (applied to each group in turn)
        `algorithm` - one of group-by, group-adjacent, group-starting-with, group-ending-with
        `key` - expression to evaluate the grouping key
        `collator` - user for comparing strings
        `collationNameExpression` - expression that yields the name of the collation to be used
        `sortKeys` - list of xsl:sort keys for sorting the groups. May be null.

  - ### Method Detail

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction for diagnostic and tracing purposes
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        the name of the instruction

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()

      If the expression is a Callable, then it is required that the order of the operands returned by this function is the same as the order of arguments supplied to the corresponding call() method.

      Specified by:
        `operands` in class `Instruction`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### getSelectExpression

          public Expression getSelectExpression()

      Get the select expression
      Specified by:
        `getSelectExpression` in interface `ContextSwitchingExpression`
      Returns:
        the select expression

    - #### getActionExpression

          public Expression getActionExpression()

      Get the action expression (the content of the for-each-group)
      Specified by:
        `getActionExpression` in interface `ContextSwitchingExpression`
      Returns:
        the body of the xsl:for-each-group instruction

    - #### getAlgorithm

          public byte getAlgorithm()

      Get the grouping algorithm (one of group-by, group-adjacent, group-starting-with, group-ending-with)
      Returns:
        one of group-by, group-adjacent, group-starting-with, group-ending-with

    - #### getGroupingKey

          public Expression getGroupingKey()

      Get the grouping key expression expression (the group-by or group-adjacent expression, or a PatternSponsor containing the group-starting-with or group-ending-with expression)
      Returns:
        the expression used to calculate grouping keys

    - #### getKeyItemType

          public int getKeyItemType()

      Get the primitive item type of the key
      Returns:
        the primitive item type of the grouping key

    - #### getSortKeyDefinitions

          public SortKeyDefinitionList getSortKeyDefinitions()

      Get the sort keys defined at the for-each-group level, that is, the keys for sorting the groups
      Returns:
        the definitions of the sort keys defined as children of the xsl:for-each-group element, or null if there are no sort keys

    - #### getSortKeyComparators

          public AtomicComparer[] getSortKeyComparators()

      Get the statically-allocated sort key comparators for sorting at the group level, if known
      Returns:
        the comparators used for comparing sort key values, one entry in the array for each nested xsl:sort element

    - #### getCollation

          public StringCollator getCollation()

      Get the statically-determined collator, or null if the collation was not determined statically
      Returns:
        the collation, if known statically, or null if not

    - #### getBaseURI

          public java.net.URI getBaseURI()

      Get the static base URI of the instruction
      Returns:
        the static base URI if known, or null otherwise

    - #### isComposite

          public boolean isComposite()

    - #### setComposite

          public void setComposite​(boolean composite)

    - #### isInFork

          public boolean isInFork()

    - #### setIsInFork

          public void setIsInFork​(boolean inFork)

    - #### allowExtractingCommonSubexpressions

          public boolean allowExtractingCommonSubexpressions()

      Ask whether common subexpressions found in the operands of this expression can be extracted and evaluated outside the expression itself. The result is irrelevant in the case of operands evaluated with a different focus, which will never be extracted in this way, even if they have no focus dependency.
      Overrides:
        `allowExtractingCommonSubexpressions` in class `Expression`
      Returns:
        false for this kind of expression

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - a mutable list of (old binding, new binding) pairs that is used to update the bindings held in any local variable references that are copied.
      Returns:
        the copy of the original expression

    - #### getItemType

          public ItemType getItemType()

      Get the item type of the items returned by evaluating this instruction
      Overrides:
        `getItemType` in class `Instruction`
      Returns:
        the static item type of the instruction

    - #### computeDependencies

          public int computeDependencies()

      Compute the dependencies of an expression, as the union of the dependencies of its subexpressions. (This is overridden for path expressions and filter expressions, where the dependencies of a subexpression are not all propogated). This method should be called only once, to compute the dependencies; after that, getDependencies should be used.
      Overrides:
        `computeDependencies` in class `Expression`
      Returns:
        the depencies, as a bit-mask

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `Instruction`
      Returns:
        a set of flags indicating static properties of this expression

    - #### mayCreateNewNodes

          public final boolean mayCreateNewNodes()

      Determine whether this instruction creates new nodes. This implementation returns true if the "action" creates new nodes. (Nodes created by the condition can't contribute to the result).
      Overrides:
        `mayCreateNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes under some input conditions (or if it can't be proved that it doesn't)

    - #### getStreamerName

          public java.lang.String getStreamerName()

      Get the (partial) name of a class that supports streaming of this kind of expression
      Overrides:
        `getStreamerName` in class `Expression`
      Returns:
        the partial name of a class that can be instantiated to provide streaming support in Saxon-EE, or null if there is no such class

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the set of nodes within the path map
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### processLeavingTail

          public TailCall processLeavingTail​(Outputter output,
                                             XPathContext context)
                                      throws XPathException

      Description copied from class: `Instruction`
      ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Specified by:
        `processLeavingTail` in class `Instruction`
      Parameters:
        `output` - the destination for the result
        `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
      Returns:
        null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### getCollationNameExpression

          public Expression getCollationNameExpression()

      Get the expression which, on evaluation, yields the name of the collation to be used
      Returns:
        the expression that returns the collation name

    - #### getGroupIterator

          public GroupIterator getGroupIterator​(Expression select,
                                                XPathContext context)
                                         throws XPathException

      Throws:
        `XPathException`

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation relies on the process() method: it "pushes" the results of the instruction to a sequence in memory, and then iterates over this in-memory sequence.

      In principle instructions should implement a pipelined iterate() method that avoids the overhead of intermediate storage.

      Overrides:
        `iterate` in class `Instruction`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### map

          public SequenceIterator map​(XPathContext context)
                               throws XPathException

      Map one item to a sequence.
      Specified by:
        `map` in interface `ContextMappingFunction`
      Parameters:
        `context` - The processing context. This is supplied only for mapping constructs that set the context node, position, and size. Otherwise it is null.
      Returns:
        either (a) a SequenceIterator over the sequence of items that the supplied input item maps to, or (b) an Item if it maps to a single item, or (c) null if it maps to an empty sequence.
      Throws:
        `XPathException` - if a dynamic error is detected

    - #### evaluateSortKey

          public AtomicValue evaluateSortKey​(int n,
                                             XPathContext c)
                                      throws XPathException

      Callback for evaluating the sort keys
      Specified by:
        `evaluateSortKey` in interface `SortKeyEvaluator`
      Throws:
        `XPathException`

    - #### getSortKeyDefinitionList

          public SortKeyDefinitionList getSortKeyDefinitionList()

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### setSelect

          public void setSelect​(Expression select)

    - #### setAction

          public void setAction​(Expression action)

    - #### setKey

          public void setKey​(Expression key)

    - #### setCollationNameExpression

          public void setCollationNameExpression​(Expression collationNameExpression)

    - #### setSortKeyDefinitions

          public void setSortKeyDefinitions​(SortKeyDefinitionList sortKeyDefinitions)